import { IGunChainReference } from 'gun/types/chain';
export declare class Node<T = unknown> {
    path: string;
    gun: IGunChainReference;
    ref: IGunChainReference;
    constructor(path: string, gun: IGunChainReference);
    private encode;
    private decode;
    /**
     * Get parent node
     */
    get parent(): Node | null;
    /**
     * Set a value
     */
    set(value: T): Promise<void>;
    /**
     * Get next nodes
     * `await stack.node('a.b').set({hello: 'world'})`
     * `await stack.node('a').next() -> [Node({path: 'a.b'})]`
     */
    next(): Promise<Node[]>;
    /**
     * Listen for node data changes
     * @param listener handler fo new data
     */
    on(listener: (data: T) => void): void;
    /**
     * Get data from node
     * @param timeout timeout for data fetching, will return null after timeout
     */
    get(timeout?: number): Promise<T | null>;
}
